package main

import (
	"fmt"
	"net/http"
	"encoding/xml"
)

type User struct {
	Name  string `xml:"username"`
	Email string `xml:"email"`
	ID    int    `xml:"id"`
}

func userRouter(w http.ResponseWriter, r *http.Request) {
	w.Header().Add("Content-type", "application/xml")
	ourUser := User{}
	ourUser.Name = "Bill Smith"
	ourUser.Email = "bill.smith@example.com"
	ourUser.ID = 100

	output, _ := xml.Marshal(ourUser)
	fmt.Fprint(w, string(output))
}

func main() {
	fmt.Println("Starting XML server")
	http.HandleFunc("/", userRouter)
	http.ListenAndServe(":8080", nil)
}
