package main

import (
	"fmt"
	"net/http"
	"launchpad.net/goyaml"
)

type User struct {
	Name  string `yaml:"username"`
	Email string `yaml:"email"`
	ID    int    `yaml:"id"`
}

func userRouter(w http.ResponseWriter, r *http.Request) {
	w.Header().Add("Content-type", "text/yaml")
	w.Header().Add("Content-disposition", "inline")
	ourUser := User{}
	ourUser.Name = "Bill Smith"
	ourUser.Email = "bill.smith@example.com"
	ourUser.ID = 100

	output, _ := goyaml.Marshal(ourUser)
	fmt.Fprint(w, string(output))
}

func main() {
	fmt.Println("Starting YAML server")
	http.HandleFunc("/", userRouter)
	http.ListenAndServe(":8080", nil)
}
