package main

import (
	"fmt"
	"net/http"
	"encoding/csv"
	"bytes"
	"strconv"
)

type User struct {
	Name  string
	Email string
	ID    int
}

func userRouter(w http.ResponseWriter, r *http.Request) {
	w.Header().Add("Content-type", "text/plain")
	ourUser := User{}
	ourUser.Name = "Bill Smith"
	ourUser.Email = "bill.smith@example.com"
	ourUser.ID = 100

	b := &bytes.Buffer{}
	wr := csv.NewWriter(b)
	wr.Write([]string{"username", "email", "id"})
	wr.Write([]string{ourUser.Name, ourUser.Email, strconv.Itoa(ourUser.ID)})
	wr.Flush()

	fmt.Fprint(w, string(b.Bytes()))
}

func main() {
	fmt.Println("Starting CSV server")
	http.HandleFunc("/", userRouter)
	http.ListenAndServe(":8080", nil)
}
